/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/* Header file */
#include "js-tokenstream.h"
#include "js-functionnode.h"

/* Class data */
const	jsString_t	JSFunctionNode::className = "FunctionNode";

/* Procedures */
jsString_t
JSFunctionNode::getFunctionName()
{
    return getString();
}

JSVariableTable *
JSFunctionNode::getVariableTable()
{
    return itsVariableTable;
}
jsBool_t
JSFunctionNode::requiresActivation()
{
    return itsNeedsActivation;
}
jsBool_t
JSFunctionNode::setRequiresActivation(jsBool_t b)
{
    return itsNeedsActivation = b;
}
int8_t
JSFunctionNode::getFunctionType()
{
    return itsFunctionType;
}
void
JSFunctionNode::setFunctionType(int8_t functionType)
{
    itsFunctionType = functionType;
}
jsBool_t 
JSFunctionNode::isInstanceOf(const jsString_t className)
{
    return className == JSFunctionNode::className;
}

JSFunctionNode::JSFunctionNode(JSContext *cx, jsString_t name, JSNode *left,
			JSNode *right)
			: JSNode(cx, JSTokenStream::FUNCTION, left, right, name)
{
    itsVariableTable = new (cx) JSVariableTable(cx);
    itsNeedsActivation = FALSE;

    cx->addVariableTable(itsVariableTable);
}
